// Solución para árboles binarios.

private:

// Pre: m no apunta a nullptr
static void aux_max_min(Node2* m, Node2*& max, Node2*& min) {
  max = new Node2;
  min = new Node2;
  max->info = min->info = m->info; 
  if (m->segE != nullptr) {
    aux_max_min(m->segE, max->segE, min->segE);
    if (max->segE->info > max->info) max->info = max->segE->info;
    if (min->segE->info < min->info) min->info = min->segE->info;    
  }
  if (m->segD != nullptr) {
    aux_max_min(m->segD, max->segD, min->segD);
    if (max->segD->info > max->info) max->info = max->segD->info;
    if (min->segD->info < min->info) min->info = min->segD->info;    
  }     
}
// Post: max apunta a la jerarquía de nodos máximos de la jerarquía de nodos
// a la que apunta m, y min a la jerarquía de nodos mínimos.



public:

void arbre_max_min(Arbre& amax, Arbre& amin) const {
/* Pre: el p.i. no és buit, amax i amin són buits */
/* Post: amax és l'arbre de màxims del p.i., amin és l'arbre de mínims del p.i. */  
  aux_max_min(primer, amax.primer, amin.primer); 
}








